/*!
 * AnyTouch.js v0.0.1
 * (c) 2018-2019 Russell
 * https://github.com/any86/vue-create-root
 * Released under the MIT License.
 */
'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function throwError(message) {
    throw ("vue-create-root: " + message);
}
//# sourceMappingURL=utils.js.map

var createRoot = function (Vue, component, data, childrenRender, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.target, target = _c === void 0 ? 'body' : _c, _d = _b.isAppend, isAppend = _d === void 0 ? true : _d;
    var vNodeData;
    var _childrenRender = childrenRender;
    var container = 'string' === typeof target ? document.querySelector(target) : target;
    if (!container) {
        throwError('target元素不存在');
    }
    var el = document.createElement('div');
    container.insertAdjacentElement(isAppend ? 'beforeend' : 'afterbegin', el);
    var root = new Vue({
        el: el,
        render: function (createElement) {
            var rootComponent = createElement(component, vNodeData, _childrenRender && _childrenRender(createElement));
            return rootComponent;
        },
    });
    var rootComponent = root.$children[0];
    rootComponent.$on('hook:destroyed', function () {
        root.$destroy();
        container.removeChild(rootComponent.$el);
    });
    rootComponent.$updateRenderData = function (newData, newChildrenRender) {
        vNodeData = ('props' in newData) ? newData : { props: newData };
        _childrenRender = newChildrenRender;
        root.$forceUpdate();
    };
    rootComponent.$updateRenderData(data, _childrenRender);
    return rootComponent;
};
//# sourceMappingURL=createRoot.js.map

var CreateRootClassWrapFunction = (function (Vue, inputComponent) {
    var _a;
    var instance;
    return _a = (function () {
            function CreateRoot(options, childrenRender) {
                this.component = createRoot(Vue, inputComponent, options, childrenRender, {});
                return this;
            }
            CreateRoot.prototype.$update = function () {
                var _b;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                (_b = this.component).$updateRenderData.apply(_b, __spread(args));
                return this.component;
            };
            CreateRoot.prototype.$destroy = function () {
                this.component.$destroy();
                return this;
            };
            return CreateRoot;
        }()),
        _a.init = function (options, childrenRender) {
            if (instance) {
                instance.$update(options, childrenRender);
            }
            else {
                instance = new _a(options, childrenRender);
                console.log(instance);
            }
        },
        _a.$update = function (options, childrenRender) {
            if (undefined !== instance && null !== instance) {
                instance.$update(options, childrenRender);
            }
        },
        _a.$destroy = function () {
            if (null !== instance) {
                instance.$destroy();
                instance = null;
            }
        },
        _a;
});
//# sourceMappingURL=CreateRootClassWrapFunction.js.map

function install(Vue, _a) {
    var _b = (_a === void 0 ? {} : _a).name, name = _b === void 0 ? '$createRoot' : _b;
    Vue.createRoot = function (component) { return CreateRootClassWrapFunction(Vue, component); };
    Vue.prototype[name] = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        createRoot.apply(void 0, __spread([Vue], args));
    };
    Vue.createRoot.version = '0.0.1';
}
var main = { install: install };
//# sourceMappingURL=main.js.map

module.exports = main;
//# sourceMappingURL=vue-create-root.common.js.map
